﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Ghoulmie
{
    public partial class Form1 : Form
    {
        public Random rnd = new Random();
        public Form1()
        {
            InitializeComponent();
        }
        public double gen_normal(double medie, double dispersie)
        {
            double Z=0;
	        int j=0;
	        while(j<12)
            {
		        Z = Z + (double)this.rnd.Next(0,1000000)/(double)1000000;
		        j=j+1;
            }
	        Z = Z - 6;
            return medie + Z * dispersie;
        }
        private void button1_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(System.IO.Directory.GetCurrentDirectory()+System.IO.Path.DirectorySeparatorChar+"Ghoulmie.pdf");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(System.IO.Directory.GetCurrentDirectory() + System.IO.Path.DirectorySeparatorChar + "D_Normala.pdf");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Pragurile decizionale pot fi generate cu butonul din stanga sau preluate din fisierul `praguri.txt` din directorul programului.\r\nDaca se apasa butonul `Generare` atunci fisierul praguri.txt este suprascris automat. Fisierul praguri.txt trebuie sa contina exact atatea linii cat este numarul de agenti N, fiecare linie continand un numar real (se utilizeaza punctul zecimal sau virgula dupa cum este setat calculatorul).");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //generez N numere aleatoare intre 0 si 3*dispersia informatiei (intre -3*sigma si 3*sigma se afla 99% dintre valorile posibile ale distributiei)
            //Presupun ca pragurile initiale ale agentilor sunt uniform distribuite pe intervalul (0.3*sigma, 3*sigma)
            System.IO.StreamWriter sw = System.IO.File.CreateText(System.IO.Directory.GetCurrentDirectory() + System.IO.Path.DirectorySeparatorChar + "praguri.txt");
            for (int i = 0; i < (int)this.nr_agenti.Value; i++)
            {
                sw.WriteLine((((double)3 * (double)this.dispersie.Value * (double)rnd.Next(100000, 1000000))/(double)1000000).ToString());
                sw.Flush();
            }
            sw.Close();
            sw.Dispose();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Probabilitatile de schimbare a pragurilor pot fi generate cu butonul din stanga sau preluate din fisierul `prob.txt` din directorul programului.\r\nDaca se apasa butonul `Generare` atunci fisierul prob.txt este suprascris automat. Fisierul prob.txt trebuie sa contina exact atatea linii cat este numarul de agenti N, fiecare linie continand un numar real cuprins intre 0 si 1(se utilizeaza punctul zecimal sau virgula dupa cum este setat calculatorul).");
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //generez N numere aleatoare uniform distribuite intre 0 si 1
            System.IO.StreamWriter sw = System.IO.File.CreateText(System.IO.Directory.GetCurrentDirectory() + System.IO.Path.DirectorySeparatorChar + "prob.txt");
            for (int i = 0; i < (int)this.nr_agenti.Value; i++)
            {
                sw.WriteLine((((double)rnd.Next(100000, 1000000)) / (double)1000000).ToString());
                sw.Flush();
            }
            sw.Close();
            sw.Dispose();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.evolutie.Text = "";
            double[] praguri = new double[(int)this.nr_agenti.Value];
            double pret_actual = (double)this.pret_init.Value;
            double pret_viitor = 0;
            this.evolutie.AppendText(this.pret_init.Value.ToString());
            try
            {
                System.IO.StreamReader sr = System.IO.File.OpenText(System.IO.Directory.GetCurrentDirectory() + System.IO.Path.DirectorySeparatorChar + "praguri.txt");
                string linie = "";
                int i = 0;
                while ((linie = sr.ReadLine()) != null)
                {
                    praguri[i] = double.Parse(linie);
                    i++;
                }
                sr.Close();
                sr.Dispose();
            }
            catch(Exception ex)
            {
                MessageBox.Show("Fisierul praguri.txt nu exista, nu are acelasi numar de linii cu numarul de agenti sau este prost formatat");
            }
            double[] prob = new double[(int)this.nr_agenti.Value];
            try
            {
                System.IO.StreamReader sr = System.IO.File.OpenText(System.IO.Directory.GetCurrentDirectory() + System.IO.Path.DirectorySeparatorChar + "prob.txt");
                string linie = "";
                int i = 0;
                while ((linie = sr.ReadLine()) != null)
                {
                    prob[i] = double.Parse(linie);
                    i++;
                }
                sr.Close();
                sr.Dispose();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fisierul prob.txt nu exista, nu are acelasi numar de linii cu numarul de agenti sau este prost formatat");
            }
            double[] informatii = new double[(int)this.nr_agenti.Value];
            for (int j = 0; j < (int)this.orizont_timp.Value; j++)
            {
                //1. Generez informatiile de la pasul i
                for (int i = 0; i < (int)this.nr_agenti.Value; i++)
                {
                    informatii[i]=this.gen_normal((double)0,(double)this.dispersie.Value);
                }
                //2. Calculez Z
                double Z=0;
                for (int i = 0; i < (int)this.nr_agenti.Value; i++)
                {
                    if (informatii[i] < (-1) * praguri[i])
                    {
                        Z = Z - 1;
                    }
                    else if (informatii[i] > praguri[i])
                    {
                        Z = Z + 1;
                    }
                }
                //3. Calculez noul pret p(t+1)=p(t)*e^(Z/lambda);
                pret_viitor = pret_actual*Math.Exp((Z/(double)this.nr_agenti.Value)/(double)this.adancime.Value);
                this.evolutie.AppendText("\r\n"+pret_viitor.ToString());
                //4. Decid care agenti isi modifica pragurile
                for (int i = 0; i < (int)this.nr_agenti.Value; i++)
                {
                    if (((double)rnd.Next(100000, 1000000)) / (double)1000000 > prob[i])
                    {
                        praguri[i] = (Z / (double)this.nr_agenti.Value) / (double)this.adancime.Value;
                    }
                }
                //Reinitializez valorile
                pret_actual = pret_viitor;
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Deocamdata este generata doar evolutia pretului.\r\nPentru afisare grafica se face copy-paste din lista din stanga in coloana C incepand cu linia 2 in fisierul excel asociat");
        }
    }
}
